Summary: standard shared libraries for programs
Name: libc
Version: 5.4.46
Release: 2rh42
ExclusiveArch: i386
ExclusiveOS: Linux
Copyright: GPL
Group: Libraries
Source: ftp://sunsite.unc.edu:/pub/Linux/GCC/libc-%{PACKAGE_VERSION}.tar.gz
Patch0: libc-5.4.43-config.patch 
Patch1: libc-5.4.43-wchar.patch 
Patch2: libc-5.4.46-realpath.patch 
#Patch1: libc-5.4.28-locale.patch
#Patch2: libc-5.4.28-links.patch
#Patch3: libc-5.4.31-1.librarylinkage.patch
BuildRoot: /tmp/libc-root
Requires: ld.so >= 1.9.9
Requires: binutils >= 2.7.0.3
Requires: gcc >= 2.7.2
#Packager: Timo Karjalainen <timok@iki.fi>
#Packager: Toshio Kuratomi <badger@prtr-13.ucsc.edu>
#Packager: Daisuke SUZUKI <daisuke@linux.or.jp>
#Packager: Jun NISHII <nishii@postman.riken.go.jp>
Packager: Jochen Stein <jst@writeme.com>
Conflicts: redhat-release >= 5.0

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a
Linux system will not function.

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries/Libc
Requires: kernel-headers binutils

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and
object files available for creating the executables.

%package static
Summary: Libraries for static linking
Group: Development/Libraries/Libc
Requires: binutils

%description static
While most programs are distributed dynamically linked, and therefore need
access to the standard shared libraries, some developers prefer to
ship programs statically linked, which includes all of the standard library
code in the executable. While this results in significantly larger
programs and increases their memory usage, it does increase the portability
of programs between Linux systems.

%package profile
Summary: libc with profiling support
Group: Development/Libraries/Libc
Requires: binutils

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%package debug
Summary: libc with debugging information
Group: Development/Libraries/Libc
Requires: binutils

%description debug
These libraries have the debugging information debuggers use for tracing
the execution of programs. These are only needed when the shared libraries
themselves are being debugged -- they are not needed to debug programs which
use them.

%package -n locale
Summary: Tools for manipulation locale definition files for other languages
Group: Utilities/Text

%description -n locale
This package includes the tools necessary to generate and manipulate the
locale definition files that libc uses to provide multi-lingual support.

%changelog
* Sun Oct 25 1998 Jochen Stein <jst@writeme.com>

- Security fix from Olaf Kirch included

* Sun Jun 28 1998 Jochen Stein <jst@writeme.com>

- Version 5.4.46
- now requires ld.so 1.9.9

* Sat Feb 21 1998 Jochen Stein <jst@writeme.com>

- Version 5.4.44
- Fixed some clashes with other packages

* Thu Sep 25 1997 Jun NISHII <nishii@postman.riken.go.jp>

- Added /lib/{libc,libm}.so.5 in files field

* Thu Sep 22 1997 Daisuke SUZUKI <daisuke@linux.or.jp>

- Changed for gcc-2.7.2.2 or newer.

* Thu Sep 18 1997 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

- Minimal change!! Added a requirement for ld.so >= 1.9.5.

* Tue Sep 16 1997 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

- Version 5.4.38

* Sat May 31 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.33
- Changed BuildRoot to use /tmp instead of /var/tmp
- Binaries of locale & localedef are now stripped.
- Removed 'make depend'
- Removed RPM_OPT_FLAGS

* Tue May 27 1997 Toshio Kuratomi <badger@prtr-13.ucsc.edu>

- Added ${RPM_OPT_FLAGS} to the make CFLAGS
- Patched locale/Makefile to get it to link the new library in.
- Changed libc-5.4.28-config.patch to properly use BuildRoot

* Sun May 25 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.31

* Mon May 19 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.30
- Some minor changes to spec-file

* Mon May 12 1997 Timo Karjalainen <timok@iki.fi>

- Version 5.4.28
- Added locale-patch from libc-5.4.26-package I found from contrib.

%prep
%setup -c
%patch0 -p1
%patch1 -p1 -b .wchar
%patch2 -p1 -b .realpath
#%patch2 -p1 -b .links
#%patch3 -p1 -b .library

find . -name "*.wchar" | xargs rm

cd libc
make clean

# Assumes that the kernel sources are in their standard places...
cd ..
ln -s /usr/src/linux/include/{asm,linux} include	

cd libc
mv config.in config.in.tmpl
sed "s&REPLACEMEWITHTARGET&$RPM_BUILD_ROOT/&" < config.in.tmpl > config.in

%build

cd libc

./configure <<EOF

EOF

make  OPT_CFLAGS="${RPM_OPT_FLAGS} -O99"
make  OPT_CFLAGS="${RPM_OPT_FLAGS} -O99" -C locale programs

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/{etc,usr/bin}

tar cvSpf - include | tar xCSpf $RPM_BUILD_ROOT/usr -

cd libc
make RPM_BUILD_ROOT="$RPM_BUILD_ROOT" install
install -m 644 -o 0 -g 0 nys/nsw/etc/nsswitch.conf $RPM_BUILD_ROOT/etc
install -m 755 -o 0 -g 0 -s locale/{locale,localedef} $RPM_BUILD_ROOT/usr/bin

# Delete some stuff that we get from other packages..
rm -f $RPM_BUILD_ROOT/usr/include/{pthread.h,ansidecl.h,asm,linux}
rm -f $RPM_BUILD_ROOT/usr/include/obstack.h # from binutils
rm -f $RPM_BUILD_ROOT/usr/include/Makefile

cd $RPM_BUILD_ROOT/lib
ln -s /lib/libc.so.%{PACKAGE_VERSION} libc.so.5
ln -s /lib/libm.so.5.0.9 libm.so.5
ln -s /lib/libc.so.%{PACKAGE_VERSION} libc.so
ln -s /lib/libm.so.5.0.9 libm.so

cd $RPM_BUILD_ROOT/usr/lib
ln -sf /lib/libc.so.%{PACKAGE_VERSION} libc.so
ln -sf /lib/libm.so.5.0.9 libm.so

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%config /etc/nsswitch.conf
%doc libc/release.libc libc/ChangeLog
%doc libc/README.nys libc/nys/README libc/nys/nis/etc/nis.conf libc/nys/yp/etc/yp.conf
/lib/libc.so.%{PACKAGE_VERSION}
/lib/libm.so.5.0.9
/lib/libc.so.5
/lib/libm.so.5
/lib/libc.so
/lib/libm.so

%files devel
/usr/lib/*.o
/usr/lib/libbsd.a
/usr/lib/libgmon.a
/usr/lib/libmcheck.a
/usr/lib/*.so
/usr/include/*

%files static
/usr/lib/libc.a
/usr/lib/libm.a

%files profile
/usr/lib/libc_p.a

%files debug
/usr/lib/libg.a

%files -n locale
/usr/bin/locale
/usr/bin/localedef
